.286
NewProgramSize equ 1000h
NewStackOfs    equ NewProgramSize - 0002h
text segment byte public
	assume cs:text,ds:text
	org 100h
begin:  mov  sp,NewStackOfs     ; Set new stack
        mov  bx,NewProgramSize shr 4
        mov  ah,4ah
        int  21h                ; Set new program size
        jnc  @MemFree
        call @Error
        jmp  @GoDos
@MemFree:
; Example of use int 2eh - begin
        mov  si,offset CMD
; ds:si = to Command Line
; Save all registers - stack will be lost
        pusha           ; Save all general registers
        push ds         ; Save ds
        push es         ; Save es
        mov  word ptr cs:@SS+1,ss
        mov  word ptr cs:@SP+1,sp
        int  2eh        ; Execute CMD - all registers will be destr.
        cli
@SS:    mov  ax,0000h   ; Restore our stack
        mov  ss,ax
@SP:    mov  ax,0000h
        mov  sp,ax
        sti
        pop  es         ; Stack OK - restore registers
        pop  ds
        popa
; Example of use int 2eh - end
        mov  si,offset Keys
        call PutKeys
@GoDos: mov  ax,4c00h
        int  21h
@Error: mov  dx,offset ErrorMess
        mov  ah,09h
	int  21h
	retn
PutKeys proc near
        cld
@Key:   lodsw
        test ax,ax
        jnz  @NoEndKey
        retn
@NoEndKey:
        mov  cx,ax
        call PutKey
        jmp  short @Key
PutKeys endp
PutKey proc near
        mov  ah,05h
        int  16h
        retn
PutKey endp
CMD        db 8,'test.bat',0dh
Keys       db 'e',12h,'x',2dh,'i',17h,'t',14h,0dh,1ch,0,0
ErrorMess  db 'Error !',13,10,'$'
text ends
	end begin